


B5ENCODE_FORMAT(5)        FILE FORMATS         B5ENCODE_FORMAT(5)



NAME
     B5Encode3, B5E3 - is a Big5 character  encoding  method  for
     converting  the Big5 characters into a 7-bit ASCII represen-
     tation with printable ASCII codes in the range  of  0x21  to
     0x7e.

     It could be used for sending chinese characters over commun-
     ication  paths  where the 8-bit chinese characters cannot be
     transmitted safely (not 8-bit clean) or where the high  bits
     of  the chinese characters would be stripped by the applica-
     tions.

     The B5E3 encoding method is easy to implement in  that  only
     'high  bit  clear'  and  'add-by-a-constant'  operations are
     required to convert  the  characters  into  printable  ASCII
     codes.

DESCRIPTION
     A Big5 character contains two bytes. The fisrt  (high)  byte
     falls  in  the  range of 0xa1-0xfe and the second (low) byte
     falls either in the range of 0x40-0x7e or 0xa1-0xfe. To  map
     these  codes  into  a two byte representation with printable
     ASCII codes (0x21-0x7e), we need TWO such  94x94  blocks  to
     hold  all  the  big5  characters.  These  two blocks will be
     called the Block-1 and Block-2 of Big5 characters. Each Big5
     Block further contains two sub-blocks, one with low bytes in
     the (0x40-0x7e) range and another in (0xa1-0xfe).

     In the B5E3 mapping method, the characters whose high  bytes
     are  below the middle of the 0xa1-0xfe range (ie., high byte
     < 0xd0) is mapped to Block-1 and the  other  characters  are
     mapped to Block-2.

     A character (Hi,Lo) in the first block  (i.e.,  0xa1  <=  Hi
     <=0xcf,  and  0x40 <= Lo <= 0x7e, or 0xa1 <= Lo <= 0xfe) can
     be mapped to a double-byte character (hi,lo) in  the  (0x21-
     0x7e,0x21-0x71)  rannge  by applying the following high-byte
     operation (Hop) and low-byte  operation  (Lop)  to  the  two
     bytes respectively. (All numbers are in hexidecimal.)

          ---------------------------------------------
          Hi        Lo        Hop  Lop  hi        lo
          ---------------------------------------------
          a1-cf     a1-fe     CLR  CLR  21-4f     21-7e
          a1-cf     40-7e     -51  NOP  50-7e     40-7e
          ---------------------------------------------

     where CLR means to 'clear the high bit' of the  Hi/Lo  byte,
     NOP  means 'no operation is required' and the constant -0x51
     means to add it to the Hi byte. This means to clear the high
     bits  of  the  characters  in the (0xa1-0xcf,0xa1-0xfe) sub-
     block of codes, and add a negative constant (-0x51)  to  the



Sun Release 4.1  Last change: 25 September 1994                 1






B5ENCODE_FORMAT(5)        FILE FORMATS         B5ENCODE_FORMAT(5)



     high   byte  of  the  characters  in  the  sub-block  (0xa1-
     0xcf,0x40-0x7e) so that it is moved to the RIGHT  hand  side
     of  the  bit-cleared  sub-block  in  the code space. See the
     `B5ENCODE.spec'  file  of  this  package  for  a   graphical
     representation  of  such  operations  when  you consider the
     (Hi,Lo) or (hi,lo) bytes as the  (x,y)  coordinates  in  the
     code space.

     The decoding can be done by setting the cleared bits or sub-
     tracting the negative constant.

     For a character in  the  second  block,  similar  operations
     could  be applied as shown in the following table, simply by
     using bit-clear and addition operations. The  decoding  from
     (hi,lo) to (Hi,Lo) could also be performed with high-bit-set
     and subtraction. In  this  case,  the  (0xd0-0xfe,0xa1-0xfe)
     sub-block  is  high-bit-cleared  to  the B5E3 code sub-block
     (0x50-0x7e, 0x21-0x7e) and the (0xd0-0xfe,  0x40-0x7e)  sub-
     block  is  moved  horizontally  to the LEFT of the high-bit-
     cleared sub-block.

          ---------------------------------------------
          Hi        Lo        Hop  Lop  hi        lo
          ---------------------------------------------
          d0-fe     a1-fe     CLR  CLR  50-7e     21-7e
          d0-fe     40-7e     -af  NOP  21-4f     40-7e
          ---------------------------------------------

     Note that: all characters in (0xa1-0xfe,  0xa1-0xfe)  (i.e.,
     those  characters with 0xa1 <= Lo <= 0xfe) are mapped to its
     B5E3 code simply by clearing the high bits of the  Hi  &  Lo
     bytes.   Characters  with  0x40 <= Lo <= 0x7e are moved hor-
     izontally to the RIGHT/LEFT of the bit-cleared sub-blocks by
     adding  a  constant (-0x51 or -0xaf, depending on whether it
     is a Block-1 character or Block-2).

ESCAPE CHARACTERS
     To distinguish the Block-1 and Block-2 characters from ASCII
     characters  and  other characters encoded with the HZ method
     for GB codes, we use a `~1' escape sequence as the prefix of
     a  string  of Block-1 characters, and use `~2' as the prefix
     of Block-2 character strings. The end of such  a  string  is
     either  terminated with a `~}' sequence (into ASCII mode) or
     any other sequence in `~1',  `~2'  and  `~{'  (ESC  into  GB
     mode).   This  is  consistent  with  the HZ encoding method.
     Therefore, a HZ encoder and decoder can be  easily  extended
     to handle a mixture of such HZ + HZ extensions. Other escape
     sequences recognized by B5E3 include `~~' for a  single  `~'
     in the ASCII mode, and `~\n' for line-continutation.

OTHER INFORMATION
     For more technical information and  the  contributors  whose



Sun Release 4.1  Last change: 25 September 1994                 2






B5ENCODE_FORMAT(5)        FILE FORMATS         B5ENCODE_FORMAT(5)



     efforts    triggered   this   encoding   method,   see   the
     `B5ENCODE.spec' file included in this package.  In  particu-
     lar,  Stephen  G.  Simpson (simpson@math.psu.edu) raised the
     Big5 7-bit encoding problem in this stage of discussion  and
     propsed a HZ-S (HZ+) encoding method in the early discussion
     stage.  Fung  Fung  Lee  (lee@umunhum.stanford.edu)  is  the
     author  of the HZ.spec (1989) and a recent proposal EHZ. The
     HZ-2    proposal    (May,    1993)     of     Ya-Gui     Wei
     (yawei@cs.indiana.edu) has suggested to divide the high-byte
     range in the middle and thus has the effect of putting  more
     characters  in  the Big5 Block-1 to reduce swtiching between
     the two blocks. Other knowledgeable persons involved in  the
     CCNET-L discussion list should also be acknowledged.

SEEALSO
     b5encode(1), b5decode(1), betty(1), ccf(1)







































Sun Release 4.1  Last change: 25 September 1994                 3



