


B5ENCODE(1)              USER COMMANDS                B5ENCODE(1)



NAME
     b5encode, b5decode - a Big5 character encoding and  decoding
     package for converting Big5 chinese characters into an ASCII
     7-bit Big5 character representation (called the B5E3 format)
     or decoding B5E3 characters back into Big5 characters.

     Optionally, the Big5 codes can also be encoded into  the  HZ
     encoding  method  for  GB, which is widely used in Mainland,
     and the GB codes can be encoded either into HZ  or  B5E3.  A
     mixture  of  ASCII, HZ, B5E3 document can also be decoded to
     either Big5 or GB.

     By such encoding and decoding, the Big5  characters  can  be
     send over communication paths where an 8-bit clean path can-
     not be found or where the high bits of the  Big5  characters
     would  be  stripped  by  the  applications such as old email
     facilities.

SYNOPSIS
     b5encode [-h|-b7|-bh|-bo|-g7|-gh|-go] < SrcFile [> TrgFile ]

     b5decode [ -h|-b|-g ] < SrcFile [ > TrgFile ]

DESCRIPTION
     The current  revision  includes  a  7-bit  encoding  method,
     called B5Encode3/B5E3, for encoding the Big5 characters.  It
     also supports the HZ 7-bit encoding method for GB, which  is
     widely   used   in   newsgroups  like  alt.chinese.text  and
     chinese.*.  See  the  documents  of  this  package  for  the
     specification of the B5E3 encoding scheme.

     Such encoding methods are intended for mail or other  appli-
     cations  which cannot find an 8-bit clean communication path
     for sending high-bit-set Big5 (or GB) characters directly or
     where  the  applications  would  strip  the high bits of the
     chinese characters.

     The b5encode command allows cross encoding from either  Big5
     or  GB  into  either B5E3 or HZ, or a mixture of HZ+B5E3 (in
     what is called the optimal conversion mode to avoid informa-
     tion loss for untranslatable characters between the Big5 and
     GB character sets.)

     The  decoding  mechanism  allows  you  to  decode  a   mixed
     ASCII/BIG5(/GB)/HZ/B5E3  (7-bit  Big5)  document  (or a pure
     HZ/B5Encode3 doucment) since the B5E3 encoding method is  an
     extension to the HZ encoding scheme.  Other such extensions,
     which  are  not  completely  integrated  in  this  revision,
     include HZ-2, HZ+S (HZ+) and B5E1, B5E2 formats.

     b5encode and b5decode both work as a normal filter for scan-
     ning  standard  input  data  stream  and  writting converted



Sun Release 4.1   Last change: 18 October 1994                  1






B5ENCODE(1)              USER COMMANDS                B5ENCODE(1)



     output to standard output.  An input source file SrcFile can
     be  redirected  for  input  and a target file TrgFile can be
     redirected for receving output.  The standard input is  read
     if there is no SrcFile specified.

COMMON OPTIONS
     By default, b5encode reads  Big5  files  and  produces  B5E3
     files;  and  b5decode  decodes a B5E3 file (or B5E3+HZ+ASCII
     mixture) into a Big5 file.

     -h   instructs b5encode or b5decode to print  a  short  help
          menu.

B5ENCODE OPTIONS
     -b7  instructs b5encode to read a Big5 file  and  produce  a
          7-bit B5E3 file. ( default encoding mode.)

     -bh  to read a Big5 file and produce a HZ file.  Untranslat-
          able characters are translated into a code for a square
          box.

     -bo  to read a Big5 file and produce  a  HZ  file.  However,
          untranslatable characters are encoded with B5E3 charac-
          ters  to  avoid  information  loss.  (Optimal  encoding
          mode.)

     -gh  to read a GB file and produce a HZ file.

     -g7  to read a GB  file  and  produce  a  7-bit  B5E3  file.
          Untranslatable  characters  are  translated into a code
          for a square box.

     -go  to read a GB file and produce a 7-bit B5E3  file.  How-
          ever,  untranslatable  characters  are  encoded with HZ
          characters to avoid information loss. (Optimal encoding
          mode.)

B5DECODE OPTIONS
     -b   The `b' option instructs the b5decode filter to produce
          Big5 output (default decoding mode).

     -g   The `g' option instructs the b5decode filter to produce
          GB output, instead of the default Big5 characters.

EXAMPLES
     Convert  a  Big5  file   big5file   to   its   B5E3   format
     big5file.be3:


               b5encode < big5file > big5file.be3





Sun Release 4.1   Last change: 18 October 1994                  2






B5ENCODE(1)              USER COMMANDS                B5ENCODE(1)



     Convert a Big5 file big5file into its HZ format big5file.hz:


               b5encode -bh < big5file > big5file.hz

     Convert a GB file gbfile into its HZ or B5E3 format

               b5encode -gh < gbfile > gbfile.hz


               b5encode -g7 < gbfile > gbfile.be3

     Optimal  (lossless)  cross  conversion  from  a  Big5   file
     big5file into its HZ+B5E3 format big5file.hzo:

               b5encode -bo < big5file > big5file.hzo

     Decode  a  B5E3  file  big5file.be3   (or   pure   HZ   file
     big5file.hz)  to  a  Big5  file  big5file  or  to  a GB file
     big5file.gb:


               b5decode < big5file.be3 > big5file

               b5decode < big5file.hz > big5file

               b5decode -g < big5file.hz > big5file.gb

OTHER CODES AND ON-LINE CONVERSION
     For converting other chinese codes widely used in Taiwan and
     Mainland to/from the 7-bit representations, and thus to/from
     Big5 and GB, see `ccf(1)' (chinese code filters, v1.53+).

     For on-line conversion, i.e., for simulating  your  terminal
     as  a 7-bit-code-aware terminal (actually most-chinese-code-
     aware terminal), for receving most chinese net services, and
     at  the  same  time retaining the ability to view or process
     normal files, see `betty(1)' for more instructions.

     Most b5encode and b5decode functions can  be  replaced  with
     the  larger package `ccf(1)' (chinese code filters, v1.53+).
     For instance,

               ccf -b7 big5file > big5file.be3

     is equivalent to `b5encode' and


               ccf -7b file.hz > file.b5

     is equivalent to  `b5decode'  (or  `hz2big5'  function  when
     applied to a HZ file.)



Sun Release 4.1   Last change: 18 October 1994                  3






B5ENCODE(1)              USER COMMANDS                B5ENCODE(1)



     To view BIG5/ HZ/ ASCII/ B5E3 documents or newsgroups/  bbs/
     gophers  etc.,  at  the  same time without explicit off-line
     conversion, or switching between different chinese  systems,
     the `betty(1)' package could be helpful.

AUTHOR AND CONTRIBUTORS
     Jing-Shin  Chang  (shin@hermes.ee.nthu.edu.tw),   NLP   Lab,
     Department  of  Electrical  Engineering,  National Tsing-Hua
     University, Hsinchu, Taiwan, ROC.

     Yong-Guang Zhang  (ygz@cs.purdue.edu),  the  author  of  the
     famous  hztty  package,  had  kindly  provided his codes and
     tables for the Big5 to GB conversion functions. (The mapping
     between  GB's  Japanese  symbols  and  their  counterpart in
     Big5/ETen extension is provided by the author.)

     Ricky  Yeung  (Ricky.Yeung@Eng.Sun.Com)  had  proposed   the
     encoding  convention  to  keep  untranslatable characters in
     their native (encoded) form for avoiding  information  loss.
     This  idea results in the -Xo (optimal encoding mode) option
     of the current implementation.

OTHER INFORMATION
     See the "README.1st" file for this package for more details.

     See  the  "doc/B5ENCODE.spec"  for  the  B5ENCODE   formats.
     Currently,  '~1'  and '~2' are used for the B5E3 Block-1 and
     B5E3 Block-2 characters.

SEEALSO
     b5e_format(5), betty(1), ccf(1)
























Sun Release 4.1   Last change: 18 October 1994                  4



