


BETTY(1)                 USER COMMANDS                   BETTY(1)



NAME
     betty - an on-line code converter for emulating your tty  as
     a chinese terminal so as to recognize most chinese code sets
     widely used in Taiwan and Mainland.

     It hides the code conversion process from the  source  (such
     as  netnews)  to your terminal transparently; therefore, on-
     line reading,  editing  and  posting  of  chinese  documents
     and/or  net  services are possible without explicit off-line
     conversion.

SYNOPSIS
     betty [ -ST [ -c shell_command command_arguments ] ]

     (See the "OPTIONS" section for supported S  (source)  and  T
     (target) codes.)

     exit -
          to exit from the specified conversion mode and go  back
          to the normal shell.

     @V - command  escape  to  toggle  HZ/B5E3  escape  character
          visual mode into `visible' or `invisible'.

     @I - command escape to toggle input conversion mode and thus
          disable/enable input conversion.

     @O - command escape to toggle  output  conversion  mode  and
          thus disable/enable output conversion.

     @E - command escape to exit Betty unconditionally and expli-
          citly.

     (See the "COMMAND ESCAPE" section for more details on the @X
     commands.)

DESCRIPTION
     Betty allows you to turn your chinese terminal into a  many-
     chinese-code-aware  terminal,  no  matter  it is a PC (under
     ETen/Big5, C-WINDOWS, ZWDOS/HZ etc.) or a  UNIX  Workstation
     (under    AIX:    aixterm/EUC,    SunOS(HLE):   sunview/EUC,
     cxterm/Big5, cxterm/GB, and so on).  You  could  use  it  to
     view/edit/post  chinese  files encoded in a different coding
     system with your native chinese  terminal  directly  without
     using  a  code  conversion  package and off-line conversion.
     Currently, it supports major Taiwanese codes and the GB code
     of  the  Mailand  standard; the 7-bit HZ encoding for GB and
     one of its extension,  B5Encode3/B5E3,  for  Big5  are  also
     included.

     Therefore, it allows you to read net  services  (newsgroups,
     bbs,   gophers)   transparently   without   using   off-line



Sun Release 4.1   Last change: 18 October 1994                  1






BETTY(1)                 USER COMMANDS                   BETTY(1)



     converters or switching between different  chinese  encoding
     schemes like 8-bit Big5, 7-bit HZ and its extension.

     It also allows you to send 7-bit Big5 character  (and  other
     Taiwanese code) streams (in B5E3 format) as well as GB char-
     acters (in HZ format) in mail or news, without using a  code
     conversion  package,  whenever  you  cannot  send such 8-bit
     codes directly.  Of course, your  terminal  need  not  be  a
     Big5/GB terminal in doing this.

     An application of this function would be to send mails  with
     7-bit  encoded  Big5  characters to a foreign host where you
     cannot send 8-bit Big5  (IBM5550,  EUC,  etc.)  directly  or
     where your applications (such as the mailer) would strip the
     high bits of the chinese characters.

     When your target code or terminal is a 7-bit source, like HZ
     or B5E source, the other 8-bit codes, like Big5 and GB, will
     be passed as if they were ASCII stuffs;  therefore,  reading
     7-bit  and  8-bit  net  services  at  the same time (namely,
     Big5+HZ+B5E3 or GB+HZ+B5E3) is also possible with Betty.

     For instance, you can use it on an RS6000/AIX aixterm (basi-
     cally an EUC terminal) to read Big5 newsgroups/BBSes/gophers
     and HZ newsgroups at the same time without using one  cxterm
     in  GB  mode  and another cxterm in BIG5 mode when using the
     '-e7' option.  (Of course, you can still enjoy all  the  net
     services  with  the cxterm using the '-b7' option under Big5
     mode. But you only need one cxterm now.)

     You can use it with your PC/DOS ETen environment (or KC,  C-
     Windows)  without  switching between ZWDOS and ETen.  On the
     other hand, a ZWDOS (or cxterm/GB) user who does not want to
     install  Big5  environments  may  find it useful to read the
     wide variety of chinese net services in Taiwan  through  the
     help of BeTTY.

     You should be able to use it in IBM5550 mode  or  Big5  mode
     under  OS/2-T  if  it  is correctly connected to a UNIX host
     with a terminal emulator.  You can  also  use  it  with  the
     sunview/suntools  environment  with  HLE  (traditional Hanzi
     Language Environment) supports, which is also an EUC  termi-
     nal  in  essense.   See  the EXAMPLES section of this manual
     page for more options and applications.

OPTIONS
     Betty assumes that you are using a  chinese  terminal  whose
     major   internal   code   is   specified  by  the  S  source
     code/terminal specifier, and assumes  that  your  shell  are
     sending  output  chinese  codes encoded with the target code
     specified by the T code/terminal specifier. The code conver-
     sion  between S and T is conducted on-line so that you could



Sun Release 4.1   Last change: 18 October 1994                  2






BETTY(1)                 USER COMMANDS                   BETTY(1)



     transparently read documents, net services, mails  that  are
     encoded  with  other coding system not native to your termi-
     nal.

     Betty enables such functions by creating an interactive sub-
     shell  for  your daily operations, like editing, on the UNIX
     system, and intercepts/converts the codes, on-line,  between
     your terminal (stdin) and the shell applications (stdout).

     All command line options except the  `-ST'  conversion  mode
     specifiers  are  passed  to  the  subshell as-is. Therefore,
     depending on your system shell, you maybe able to enter  the
     conversion  mode, executing a specified shell_command in the
     conversion mode and exiting the subshell  immediately  after
     the  shell_command  is  finished.   For  instance, you could
     bring up your news reader, say rn (or tin), by  telling  the
     shell to run it on the code conversion mode by using: `betty
     -b7 -c rn'.

     However, not all commands are usable in this way.  The  `-c'
     option shown here is the option for a csh or sh to execute a
     command.  It may depend on the shell you  used.  Check  your
     manual pages for your normal shell.

     -ST  Use `S' to specify the type of the input code or  input
          terminal/windows,  and use `T' for the type of the out-
          put code from  the  original  unconverted  stdout  data
          streams of the shell.

          The type of a chinese code/terminal/window is specified
          by  one  of  the following 1-character code designators
          (the characters are Case Sensitive ):

               b - BIG5 code

               i - IBM5550 code

               n - CNS-11643/86 (internal code)

               e - EUC/CNS (Extended UNIX Code)

               t - TCA (Taipei Computer Association) code

               l - Telgram code

               H - IBM Host code

               p - CNS-11643/86 (7-bit interchange protocol code)

               7 - BIG5 7-bit ASCII exchange code (in  B5E3  for-
               mat)




Sun Release 4.1   Last change: 18 October 1994                  3






BETTY(1)                 USER COMMANDS                   BETTY(1)



               g - GB code

               h - HZ 7-bit ASCII exchange code (for GB)

               o - use  optimal  conversion  mode  for  producing
               (possibly) mixed HZ+B5E3 ASCII exchange codes when
               cross-converting from  Big5  (or  other  Taiwanese
               codes) to HZ, or from GB to B5E3.  (See the "7-BIT
               CHINESE CODE SUPPORTS" section.)

     -c   The following arguments are  to  be  interpreted  as  a
          shell_command     followed     by     its    arguments,
          command_arguments, and the shell_command is to be  exe-
          cuted on the specified code conversion mode.

CHANGES IN COMMAND LINE OPTIONS
     The command line options for code set  designation  are  now
     (Rev.  1.53+) Case Sensitive because we are using `h' for HZ
     and `H' for IBM HOST code.

7-BIT CHINESE CODE SUPPORTS
     Currently, two 7-bit  encoding  methods  are  supported  for
     Chinese  characters:  the  HZ encoding method for GB and the
     B5E3 (B5encode3) encoding method for Big5. Notably, B5E3  is
     an  extension to the HZ encoding, therefore, its decoder can
     decode a mixed HZ+B5E3 document (or pure HZ, pure B5E3 docu-
     ments), say from a netnews (and at the same time pass native
     Big5 news without changing them).

     The encoder also provides cross encoding from either Big5 or
     GB  to  either  B5E3  or  HZ,  or a mixture of B5E3+HZ in an
     optimal encoding mode (using the -Xo options for  any  input
     code X described above).

     Other Taiwanese codes are currently translated to B5E3 or HZ
     by  first  converting  them  to  Big5  and  then  performing
     B5ENCOED. (Decoding is  done  in  the  reversed  direction.)
     Therefore,  it  is  possible,  for instance, to produce a HZ
     file from an UNIX EUC/CNS terminal or  window,  or  from  an
     IBM5550  terminal like an OS/2-T PC.  And all the above men-
     tioned taiwanese terminals will be able to receive Big5  net
     services  and  HZ/B5E3  services *at the same time* by using
     the '-S7' or '-Sh' mode of on-line conversion.  Similar con-
     ditions hold for a GB terminal or ZWDOS user.

     Among the cross translation between the Big5/B5E3 and  GB/HZ
     families,  an  `optimal encoding mode' for 7-bit encoding is
     supported. This mode of  translation  follows  the  idea  of
     Ricky  Yeung  (Ricky.Yeung@Eng.Sun.Com) to leave untranslat-
     able characters in their native encoded form so as to  avoid
     information  loss. In other words, such untranslatable char-
     acters will not be translated to a default character (like a



Sun Release 4.1   Last change: 18 October 1994                  4






BETTY(1)                 USER COMMANDS                   BETTY(1)



     square  box),  instead,  they  are  translated into B5E3 (if
     their source is Big5 or other Taiwaness  codes)  or  HZ  (if
     their source is GB.)

     With such a translation convention, all characters  will  be
     translated  back properly to a Big5 terminal if the original
     document is produced using the `-bo'  (Big5  to  HZ  optimal
     mode)  option  (or  most  -Xo options for Taiwanese X code);
     similarly, a  GB  terminal  user  will  see  all  characters
     translated  back  properly  for a document prepared with the
     `-ho', HZ to B5E3 optimal mode, option.

     (Note:  A  Big5  terminal  user  still  cannot  read   those
     untranslatable  characters  in a `-ho' ducument; ditto for a
     GB terminal user to read those untranslatable characters  in
     a `-bo' document with a simple terminal.  But this situation
     could be resolved by a terminal emulator or a  multi-lingual
     editor which supports multiple font sets.)

EXAMPLES
     To read ASCII, Big5, 7-bit HZ/B5E3 documents or newsgroups /
     BBS / gophers at the same time from a Big5 (or EUC) terminal
     or cxterm (in Big5 mode):


               betty -b7

               (betty -e7)

               rn (or tin, gopher,  telnet  bbs.csie.nctu.edu.tw,
               etc.)

               exit (when you want to quit from  on-line  conver-
               sion mode).

     You can also edit 7-bit Big5 files in B5E3 format (which  is
     an  extension  of  HZ  format), and view HZ/B5E3 files under
     this mode.

     If you wish to post or edit HZ files, you should use:

               betty -bh, or

               betty -bo

     (or use `betty -gh' instead if you are using a GB terminal.)

     To read Big5 (and ASCII) documents or newsgroups/BBS/gophers
     from  an  EUC  terminal  (e.g.,  sunview/SunOS(HLE), chinese
     aixterm/AIX):





Sun Release 4.1   Last change: 18 October 1994                  5






BETTY(1)                 USER COMMANDS                   BETTY(1)



          [Initialize your chinese environment if necessary,  and
          bring up the chinese windows, (See the AIX or SunOS/HLE
          sections for examples,) then:]

               betty -eb

               rn (or tin, gopher,  telnet  bbs.csie.nctu.edu.tw,
               etc.)

               exit (when you want to quit from  on-line  conver-
               sion mode).

     To edit Big5 files from an EUC terminal:


               betty -eb

               vi (or cvi/celvis)

     To send B5E3-encoded file from a GB terminal,  you  can  use
     either

               betty -g7, or

               betty -go

     To read Big5 net services and HZ-encoded net  services  with
     ZWDOS, you can use:

               betty -hb

     Before doing this,  you  probably  need  to  use  `stty  cs8
     -istrip' or `stty pass8' or other setting (depending on your
     system, see stty(1)) to inform your UNIX host not  to  strip
     the high bits when connecting to Big5 servers.

COMMAND ESCAPE
     BeTTY (Rev. 1.53+) provides a mechanism for  you  to  escape
     from  the  normal  mode of operation, and thus enable you to
     change some parameters while you  are  using  BeTTY  without
     exiting BeTTY.

     For instance, when editing a 7-bit encoded file  (in  HZ  or
     B5E3  format),  it  is  desirable to make the HZ/B5E3 escape
     characters visible; otherwise, the real line lengths may not
     match  the  visual lengths of the text lines, and the cursor
     of the editor may not reflect the real character position in
     such  cases.  The visual mode of such HZ/B5E3 escape charac-
     ters can  be  changed  by  using  the  `@V'  command  escape
     described below.





Sun Release 4.1   Last change: 18 October 1994                  6






BETTY(1)                 USER COMMANDS                   BETTY(1)



     Sometime, you may want to edit a file in the native code  of
     your terminal without converting it to the target code while
     you are in BeTTY.  In this case, you can use the  `@I'  com-
     mand escape to disable input conversion temporarily. And use
     '@I' again to resume input conversion after editing.

     You may  also  want  to  inspect  the  original  form  of  a
     (HZ/B5E3)  file  without converting it to the native code of
     your terminal. The current implementation provides the  '@O'
     command  escape for disabling or resuming output conversion.
     (One special case is to inspect an ordinary ASCII file which
     contains  the `~' HZ/B5E3 escape characters while you are in
     the HZ/B5E3 output conversion mode. The ASCII characters may
     be misinterpreted as chinese characters in such a situation.
     The '@O' command will provide a way to avoid this.)

     All such command escape modes can  be  entered  as  follows.
     You  can  enter  the command mode whenever a RETURE (`\r' or
     `\n') is just entered, and type the  following  escape  com-
     mands immediately:

     @V - toggle the HZ escape character visual mode from invisi-
          ble to visible or vice versa

     @I - toggle input conversion mode  to  disable/enable  input
          conversion.  (For instance, you may want to edit a Big5
          file, not a HZ file, temporarily, when  you  are  using
          'betty  -bh'  mode  for  reading HZ and Big5 newsgroups
          with your Big5 terminal.)

     @O - toggle output conversion mode to disable/enable  output
          conversion. (For instance, you may want to view a HZ or
          B5E3 file in its original form.)

     @E - exit BeTTY immediately (Normally, you will  exit  Betty
          by entering an 'exit' command in the current shell.)

     In other words, a sequence of '\r@X' (or '\n@X)  will  cause
     the command represented by the 'X' character to be executed.
     These double-character command will  not  be  echoed  since,
     unlike  the  RETURN, they will not be send to the shell. (If
     you see them echoed, you must be  entering  something  wrong
     :-)).

     Also, the commands can  be  entered  successively  once  you
     entered   the   command  mode.  For  instance,  '\n@I@O'  is
     equivalent to changing both the input and output  conversion
     modes.

     Such style of command escape is adopted simply to follow the
     convention  of some UNIX utilities (like 'tip', 'rsh', etc.)
     which create a sub-shell for interactive operations.



Sun Release 4.1   Last change: 18 October 1994                  7






BETTY(1)                 USER COMMANDS                   BETTY(1)



     Note that all the above command letters (V, I, O, E) are  in
     UPPER  case.   Also,  the  @I, @O commands are valid for any
     code pairs under conversion; but the @V  command  is  useful
     only for HZ or B5E3 I/O operations.

     Furthermore, the conversion-related commands will  not  have
     any  immediate  effect  to  the  characters currently on the
     screen; the new conversion mode will take effect only to the
     following  lines/screens  of characters.  Of course, you can
     reflash the screen, say using ^L in 'vi' or  using  the  'b'
     command in 'more' to scroll back one page, and thus show the
     characters with the new display or conversion mode.

     Since the command escape mode is enterned immediately  after
     a  RETURN  is  hit,  you can normally enter the command mode
     immediately after a shell command is issued, like:

          ls -lt <RETURN>

          @V             # these characters will  not  be  echoed
                         # in the terminal

     You can also enter the command mode when you  are  using  an
     editor  (e.g., to post a follow-up when reading a newsgroup)
     by hitting a RETURN and then changing to HZ ESC visible mode
     with  the  '@V' command. Before leaving the editor, you then
     resume the visual mode to invisible.

AIX CHINESE ENVIRONMENT
     To  use  this  package  with  an  RS6000  workstation  under
     AIX/UNIX with chinese (EUC/CNS) support, you need to set the
     language environment as follows:

          setenv LANG zh_TW

     then run the aixterm program to bring up a chinese xterm:

          aixterm [-geometry 80x24] &

     Under aixterm, you can then start betty by  considering  the
     AIX aixterm as an EUC terminal as follows:

          betty -e7 (for reading Big5/HZ/B5E3 and sending B5E3)

          betty -eh (for reading Big5/HZ/B5E3 and sending HZ)

          betty -eb (for reading Big5 and sending Big5 codes)

     You can then telnet to your  favoriate  bbs  sites  or  read
     newsgroups.





Sun Release 4.1   Last change: 18 October 1994                  8






BETTY(1)                 USER COMMANDS                   BETTY(1)



SunOS/HLE CHINESE ENVIRONMENT
     To use this package with a Sun workstation  under  SunOS/HLE
     with chinese (EUC/CNS) support, you need to set the language
     environment as follows:

          setenv LANG tchinese

     or set it in your start up file like this:

          if (-f /usr/share/lib/locale/LC_CTYPE/tchinese) then

          setenv LANG tchinese

          setenv DEFAULT_FONT /usr/lib/fonts/evfonts/twn.sung.16

          endif

     then run the shelltool/cmdtool program to bring up a chinese
     terminal window:

          shelltool -Wt $DEFAULT_FONT &

     or

          shelltool -Wt /usr/lib/fonts/evfonts/twn.sung.24 &

     Under shelltool, you can then start betty by considering the
     shelltool as an EUC terminal as follows:

          betty -e7 (for reading Big5/HZ/B5E3 and sending B5E3)

          betty -eh (for reading Big5/HZ/B5E3 and sending HZ)

          betty -eb (for reading Big5 and sending Big5 codes)

     You can then telnet to your  favoriate  bbs  sites  or  read
     newsgroups.

     If you have other chinese terminal or window installed, such
     as  cxterm,  you  can  of  course use it with the `-ST' pair
     properly assigned.

NOTICE ON PAGERS
     You may want to

          setenv MORE "-c -f"

     to prevent the 'more' pager program from inserting ESC codes
     (such  as  Erase-to-EOLN)  into your HZ (or B5E and other HZ
     extensions) when the (real) length of the lines  are  longer
     than  the screen width. Such ESC codes may make the decoding
     of the 7-bit chinese characters corruptted  temporarily  and



Sun Release 4.1   Last change: 18 October 1994                  9






BETTY(1)                 USER COMMANDS                   BETTY(1)



     introduce undesirable display due to the corruptted terminal
     control characters.

     The current default configuration has been set to strip  the
     HZ/B5E3  escape  sequences  from  display so that you have a
     clean screen of  chinese  characters,  and  the  above  MORE
     option  is  default  under  such  configuration to avoid the
     above situation. Also, the decoder had  provided  some  safe
     guarding check. Therefore, it may only occur ocassionally.

     If you had changed the HZ/B5E3 escape character visual  mode
     so  that  the  HZ  escape  sequences are shown in the screen
     (e.g., for easy editing), then you may want  to  change  the
     MORE  environment variable back to its default setting (nor-
     mally as '-c' in SunOS/4.x) in some cases.  In any case, you
     can  set  MORE  after entering the shell as desired when you
     noticed some undesirable visual effects  introduced  by  the
     'more'  program.   If there are little long lines in all the
     sessions, then  you  could  be  happy  not  to  change  this
     environment variable at all.

NOTICE ON EDITOR
     This package includes supports to  code  sets  of  different
     lengths  (in  bytes).  For instances, there are 2-byte codes
     (Big5,  IBM5550),  2-4-byte  codes  (EUC),  exchange   codes
     (HZ/B5E3/NSC-P) which are 2-byte for codes with escape char-
     acters.  Therefore, the line lengths of what you see  in  an
     editor  (or  in  the shell) are not necessarily what you get
     (in bytes) in the physical file.  Under such condition,  the
     cursor  positioning  may  not match the real character posi-
     tion.

     Such mismatch is also true for the  7-bit  encoding  schemes
     because, by default, the current revision strips the HZ/B5E3
     escape characters of a file when sending it to  the  screen,
     and  present  it  the  way  a Big5 user usually expect. This
     should not pose any problem in reading files/mails/news  but
     could cause problems in editing.

     If you need to edit a file, you can  use  the  `@V'  command
     escape  to  show the HZ/B5E3 escape characters while in your
     editing session, and resume it to the default invisible mode
     at  the  end of the editing session.  (Well, if you are sure
     that you won't type any wrong  chinese  characters,  or  the
     chinese  message  is  short, or you can afford to re-type an
     entire new line, ..., then you can perfectly edit it in  the
     usual  way you did for a Big5/GB file. -^^-. Most likely you
     are a pure happy READER who never  post  or  edit  files  in
     chinese; then you may never need this function.)

     For native 'vi' users, there is a list of  keyboard  mapping
     function defined either in your local file $HOME/.exrc or in



Sun Release 4.1   Last change: 18 October 1994                 10






BETTY(1)                 USER COMMANDS                   BETTY(1)



     the system default.  Since, some of the 7-bit encoded  char-
     acters  may  happen  to match such character sequences, they
     may introduce unpredictable effect when entering  the  7-bit
     codes.  You  could  just  comment  out  such mapping and get
     through with it.  An alternative is  to  use  other  editors
     (like celvis/cvi) which does not perform key stroke mapping.

NOTICE ON MAIL
     The default unix mailer uses the '~' character as  its  com-
     mand  escape  character,  which  is  also used in HZ and its
     extensions like B5E3.  If you are using  the  7-bit  chinese
     character  codes (B5E3 or HZ) for sending mails (because you
     cannot send 8-bit codes directly), you may  want  to  change
     the  default  escape  character of the mailer, or start your
     input line from the second character  position  of  a  line.
     Otherwise,  it maybe interpreted incorrectly.  To change the
     command escape character, for instance, you may use  a  'set
     escape=#' command in your .mailrc or manually in the command
     mode.  See the manual of your mail utility to see whether it
     is necessary to do this and how to avoid such situation. (Of
     course, the most important point is: the  receiver  of  your
     mails need a HZ/B5E3 decoder to understand your chinese sent
     in  this  way.  See  ccf(1),  b5decode(1),  b5encode(1)  and
     b5e_format(5) for more information.)

WHAT'S NEW
     Rev. 1.50 includes a  7-bit  encoding  method  for  encoding
     those  code  sets with essentially the same character set as
     Big5. This is intended to be used for mail or other applica-
     tions  which  cannot  find an 8-bit clean communication path
     for sending Big5 characters directly or where  the  applica-
     tions  would  strip the high bits of the chinese characters.
     See `b5e_format(5)' and the documents of  this  package  for
     the specification of the encoding scheme.

     The decoding mechanism also allows you  to  decode  a  mixed
     ASCII/BIG5/HZ/B5E3   (7-bit   Big5)   document  (or  a  pure
     HZ/B5Encode3 doucment) since the B5E3 encoding method is  an
     extension  to the HZ encoding scheme.  Other such extensions
     includes HZ-2, HZ+S (HZ+) and B5E1, B5E2.

     In Rev. 1.53, the code sets are further augmented to include
     the  GB  code, which is widely used in Mainland.  Therefore,
     almost all major chinese coding systems used in  Taiwan  and
     Mainland,  7-bit  or 8-bit, primitive internal codes or ISO-
     type  exchange  codes,  HZ-style  exchange  codes,  are  now
     cross-translatable on-line.

     The Japanese symbols  in  the  GB  code  is  mapped  to  the
     ETen/Big5 mapping so that people who need to use these char-
     acters can communicate with each other.




Sun Release 4.1   Last change: 18 October 1994                 11






BETTY(1)                 USER COMMANDS                   BETTY(1)



     The Rev 1.53 further includes command escape so that HZ/B5E3
     escape characters can be displayed/suppressed dynamically as
     a compromise between a beautified  screen  and  easiness  of
     editing.   (In  fact,  `@V' is included in Rev. 1.50 patch.)
     For suppressing input and output conversion in  some  cases,
     two escape commands are further provided.

     To avoid information loss when cross-translating the Big5/GB
     codes  to/from HZ/B5E3, an 'optimal conversion mode' conven-
     tion  is  implemented.  Any  untranslatable  characters  are
     encoded  in  their  native encoded form so that they will be
     recoverable.

AUTHOR AND CONTRIBUTORS
     Jing-Shin Chang (shin@hermes.ee.nthu.edu.tw), NLP Lab, Dept.
     of EE, National Tsing-Hua University, Hsinchu, Taiwan, ROC.

     Dan-Yi  Liu,  Institute  for  Information  Industry   (III),
     Taipei, Taiwan, ROC.  (The source codes for converting major
     chinese codes used in Taiwan are made public by III, ROC.)

     Yong-Guang Zhang  (ygz@cs.purdue.edu),  the  author  of  the
     famous  hztty  package,  had  kindly  provided his codes and
     tables for the Big5 to GB conversion functions. (The mapping
     between  GB's  Japanese  symbols  and  their  counterpart in
     Big5/ETen extension is provided by the author.)

     Ricky  Yeung  (Ricky.Yeung@Eng.Sun.Com)  had  proposed   the
     encoding  convention  to  keep  untranslatable characters in
     their native (encoded) form for avoiding  information  loss.
     This  idea results in the -Xo (optimal encoding mode) option
     of the current implementation.

OTHER INFORMATION
     See the 'README.1st' file in the package.

SEEALSO
     ccf(1), b5encode(1), b5decode(1), b5e_format(5)

















Sun Release 4.1   Last change: 18 October 1994                 12



