[HZ+B5E1/HZ+B5E2/HZ+B5E3]
@(#)$Id: hzb5e.spec,v 1.3 1994/05/21 21:19:21 shin Exp $

	Three Proposals for Mixed ASCII/GB/Big5 Representation

					Jing-Shin Chang
					(shin@hermes.ee.nthu.edu.tw)
---
** all documents mentioned here are available from:
	hermes.ee.nthu.edu.tw(140.114.28.27):/pub/shin/hzb5encode/*
---

0. Acknowledgements

The original work of the HZ specification for representing mixed ASCII/GB
character sets are due to Fung-Fung Lee (lee@umunhum.stanford.edu,09/04/1989)
and his fellows. (See "HZ.spec" for a detailed specification of the HZ
standard.) The escape sequences for switching into GB mode and switching
to the default ASCII mode in the proposals are borrowed from the original HZ
specification. (*)

The idea to extend the current HZ specification are initiated by Professor
Stephen G. Simpson (simpson@math.psu.edu). The escape sequences for entering
Big5 block 1 and block 2 are borrowed from Professor Simpson's current HZ+S
specification (v. 0.6), which is another proposal for mixing ASCII/GB/Big5
character sets. (See math.psu.edu:/pub/simpson/chinese/hzps/hzps.txt
for details on HZ+S specifications.) (*)

There are other kind persons who directly or indirectly contribute their
ideas on discussing or commenting on the advantages or disadvantages of
the current proposals. In particular, I had learned much from Ya-Gui Wei's
HZ-2, which is yet another very valuable mixed ASCII/GB/Big5 character sets
scheme. The B5E3 encoding scheme has borrowed the idea of cutting the
high-byte range of 0xa1-0xfe at the middle from HZ-2.

All credits concerning the related materials and efforts should be given to
the respective authors or contributors.

Thanks are due to all these kind persons. I love all of them. (**)

---
P.S. (*) If they don't borrow me such escape sequences, I will have big
	trouble. I will then need to invent my own wheels. -^^-
    (**) What would happen if I don't love them ?? -^^-
---

1. Motivation

Due to the very complex communication environment in the world-wide
network systems, there is the demand for communicating with
chinese safely. One possible way for safe communication with Chinese
characters through the network is to use 7-bit encoding of Chinese
characters.

There are two major chinese user groups: one of them uses the GB code
for their daily life and the other group uses the Big5 code for computer
applications. To allow communication between these two groups, we need
a way to integrate these two systems into a unified one.
We thus need a 7-bit standard for such communication purposes.

Currently, there is already a HZ standard for mixing ASCII and GB with
7-bit printable ASCII characters (0x21-0x7e). In this document, I will
propose two solutions for representing the Big5 code with 7-bit printable
ASCII characters. These two encoding schemes will be called B5encode-1/
B5decode-1 and B5encode-2/B5decode-2, or B5E1 and B5E2, respectively.
Such encoding schemes for converting 8-bit Big5 to/from 7-bit Big5, when
combined with appropriate escape sequences, will enable us to mix ASCII/
GB/Big5 with 7-bit printable ASCII characters. The mixed character set
encoding schemes will be referred to as HZ+B5E1 and HZ+B5E2, respectly.
(When there is no confusion, you could still call them B5E1 and B5E2.)

2. The Big5 Map

The big5 code set is a two-byte code set with the following code space:

/*
 * @(#) Jing-Shin Chang, EE, NTHU, Hsinchu, Taiwan, ROC.
 *
ASCII:	0x00 - 0x1f	- control characters
	0x20 - 0x2f	- space and symbols
	0x30 - 0x39	- digits (0 - 9)
	0x3a - 0x40	- symbols
	(0x20- 0x40	- symbols and digits)
	0x41 - 0x5a	- upper case
	0x5b - 0x60	- symbols
	0x61 - 0x7a	- lower case
	0x7b - 0x7e	- symbols
	0x7f (127)	- DEL
Big5:	High Bytes:	0x81-0x8d,0x8e-0xa0,0xa1-0xfe
			(0x01-0x0d,0x0e-0x20,0x21-0x7e,
			when high bit stripped)
	Low  Bytes:	0x40-0x7e,0xa1-0xfe
	a0: ' ' | 0x80, a1: '!' | 0x80, fe: '~' | 0x80

    High Bytes
    00            7e 80 81  8d 8e     a0 a1 a3 a4  c6 c9  f9 fa fe ff
00 +----------------------------------------------------------------+
   |                                                                |
   |                                                                |
3f +----------------------------------------------------------------+
40 +--------------------*----*-.-------.-*---*-#----#-!----!-x---x--+
 : | 40-7e: 63 chars    * U  * . U     . * S * # S  # ! A  ! x U x  |
 : |                    * 3  * . 2     . * P * # T  # ! L  ! x 1 x  |
 : |                    *    * .       . * C * # D  # ! T  ! x   x  |
7e +--------------------*----*-.-------.-*---*-#----#-!----!-x---x--+
80 (NULL|0x80)
81 +----------------------------------------------------------------+

a1 +--------------------*----*-.-------.-*---*-#---#--!----!-x---x--+
 : | a1-fe: 94 chars    * U  * . U     . *   * # S #  ! A  ! x U x  |
 : |                    *    * .       . * bf* #   #  !    ! x   x  |
 : |                    * 3  * . 2     . * c0$ # T #  ! L  ! x 1 x  |
 : |                    *    * .       . *   $ #   #  !    ! x   x  |
 : |                    *    * .       . * e0$ # D #  ! Td5! x   x  |
 : |                    *    * .       . *     #   #  !      x   x  |
fe +--------------------*----*-.-------.-*-----#---#--!------x---x--+
ff (DEL)

	SPC: special symbols
	STD: standard (commonly used) characters
	ALT: alternative set of (less frequently used) characters
	U1: user-defined code area #1
	U2: user-defined code area #2
	U3: user-defined code area #3
*/

There are different vender-specific extension to the original Big5 code.
Therefore, I will handle the following 4 blocks of codes to cover all
such possible extension:

	Freq-2 (F2): (0xa1-0xc8,0x40-0x7e)
	Freq-1 (F1): (0xa1-0xc8,0xa1-0xfe)
	Rare-2     : (0xc9-0xfe,0x40-0x7e)
	Rare-1 (R1): (0xc9-0xfe,0xa1-0xfe)

The 2nd and 3rd user-defined code space (U2 and U3) will not be handled
because they have very little chance to be used. In fact, we probably should
not even touch such non-uniquely defined code area. Note that:

	Blocks Freq-1 and Freq-2 contain frequently used characters
	and symbols.

	Blocks Rare-1 and Rare-2 contain less frequently or rarely used
	characters.

	(We use the suffix '1' to designate the code space with more codes
	and '2' for the code space that has a smaller area.)

3. Escape Sequences for Switching between Different Character Sets

The following escape sequences are used for switching from one character
set to another and locked in that character set. The default character set
is the ASCII character set.

	HZ Escape Sequences: (the same as in the original HZ standard)

	~{	-- enters GB mode, each double-byte is regarded as
			a GB character

	~}	-- enters ASCII mode, each byte is interpreted as
			an ASCII character with the following two
			exceptions:

	~~	-- represents the '~' character (0x7e)

	~\n	-- line continuation mark, the characters in the next
			line should be concatenated with the current
			line

	HZ+S Escape Sequences: (the same as in HZ+S, v. 0.6, proposal.
				However, they could be changed if desirable.)

	~1	-- switches into Big5 block 1, each double-byte is regarded
			as a Big5 character in Block 1

	~2	-- switches into Big5 block 2, each double-byte is regarded
			as a Big5 character in Block 2

The division of Big5 codes into two blocks is essential since there are
only 94x94=8836 double-byte printable ASCII characters (0x21-0x7e) available
while there are more than 130K Big5 codes. We will sometimes refer to
the Big5 block 1 simply as ~1 and block 2 as ~2 in the following sections.

Different division of the original Big5 code space into two blocks and
the mapping method from the codes in one block into the
(0x21-0x7e,0x21-0x7e) code space determine the characteristics of the
transformed 7-bit Big5 codes (hereinafter, Big5/7, in contrast to their
8-bit counterpart, Big5/8). Two proposals are given here based on two
different criteria.

4. Mapping Method I: The B5E1 Mapping Method

	---
	(* Based on B5E1/B5encode-1: 1994/05/02, B5encode/B5decode, Rev. 1.2)
	---

The first way to divide the original code space is shown as follows:

	original code space        ==>  transformed code space

         High Bytes

         a1                     fe         21                    7e
  L  40  ************************       40 ************************
  o      *                      *          *                      *
  w      * Block 2              *  ==>     *  Block 2             *
         *                      *          *                      *
  B  7e  ************************       7e ************************
  y  a1  ++++++++++++++++++++++++       21 ++++++++++++++++++++++++
  t      +                      +          +                      +
  e      +                      +          +                      +
  s      + Block 1              +  ==>     +  Block 1             +
	 +                      +          +                      +
	 +                      +          +                      +
     fe  ++++++++++++++++++++++++       7e ++++++++++++++++++++++++

The codes in Block 1 have the 8-th bit set in both their high bytes and
low bytes. On the other hand, in Block 2, the 8-th bit of the high bytes
are set BUT the 8-th bit of the low bytes are cleared. For such partition,
we can map the big5 codes into the printable area simply as follows:

	1. clear all the 8-th bits of the high bytes when we encounter
		a big5 code.

	2. clear the 8-th bits of the low bytes only for codes in Block 1
		but keep them untouched if the codes belong to Block2

	3. use the appropriate escape sequence to distinguish codes in
		block 1 and block 2

The encoding and decoding for each character requires at most two
LOGICAL operations (ANDs or ORs) for clearing or setting the 8-th bits,
instead of using multiplications and divisions for address calculation, or
using table lookup for adding offsets in the mapping process. Therefore,
the encoding and decoding is extremely simple.

To implement the encoding and decoding of HZ+B5E1 scheme, we only need two
simple finite state machines with a very small number of states.
The main operations will be logical ANDs and ORs without using multiplications
and divisions or table lookup. The computation load can thus be ignored.
And switching between the original and the transformed code space can be
done easily with two C statements.

Two programs, called "b5encode.c" (rev. 1.2) and "b5decode.c" (rev. 1.2)
are available in

	hermes.ee.nthu.edu.tw:/pub/shin/hzb5encode/b5encode-1

to show the simple implementation. The sample decoder could parse a mixed
ASCII/GB/Big5 text in the current decoder implementation, with characters
in the GB modes pass-through to the output. At least 1M bytes of big5 files
had been tested.

Such a 8-bit to 7-bit mapping method is also used in some CNS or EUC-based
chinese email implementation. For instance, the SunMicro's implementation of
the Chinese/Japanese/Korean email transmission in its Asia Language
Environment also used the same mapping process to change the 8-bit codes
(Big5 or EUC) to 7-bit streams before the email is deliveried. (The EUC for
chinese character set used in Taiwan has a very trivial mapping with
CNS-11643/86).

The internal codes (8 bit) and the exchange codes (7 bit) for CNS/11643-86
also has the same simple mapping. Therefore, we can easily modify the same
b5encode and b5decode procedures to support existing implementations
in news and email postings.

(* The HZ/GB mapping is essentially using bit set/clear too.)

The major criticism to such a division is: the switching between Big5 block 1
and block 2 will be frequent, and thus introduces more ~2 escape sequences,
and a larger file size. However, for its extremely simple mapping and negligible
computation load, people (software contributors, users) may find it a good
choice as file size is no more a big deal with extremely cheap storage
devices, high communication speeds and data compression protocols of the
present day computing environments.

Note that: the EUC/8 <-> EUC/7 and CNS/8 <-> CNS/7 does not have such a
switching problem since all frequently used characters in EUC or CNS are
already arranged in their 1st plane, and less frequently used characters are
arranged in the 2nd plane. EUC/8 or CNS/8 here refers to their 8-bit version
(e.g., internal code representation), and EUC/7 or CNS/7 refers to their
7-bit version.

5. Mapping Method II: The B5E2 Mapping Method

	---
	(* Based on B5E2/B5encode-2: 1994/05/07, B5encode/B5decode, Rev. 1.4)
	---

Another way to map the Big5/8 code to Big5/7 code is to divide the code space
according to the frequency of use into two blocks, then make the 8-bit bytes
into 7-bit bytes.

In the second encoding scheme, we therefore designate codes in Freq-1 and
Freq-2 area as Block 1 codes, and codes in Rare-1 and Rare-2 areas as Block 2
codes. Under such circumstances, the switching between Block 1 and Block 2
will be reduced to the same amount as any other proposals which divide
the Block boundaries in the same way.

5.1. Mapping of Frequently Used Characters

It is easy to map codes in Freq-1 (F1) by bit-clear, and map codes in Freq-2
(F2) by adding a constant X-offset to the X-coordinate (high byte) without
changing the Y-coordinate (low byte) of the code. The mapping table is shown
as follows:

** Mapping for Frequently Used Chars: (note: all geometries are retained) **

	F1 = Freq-1, F2 = Freq-2

        High Bytes
        a1      c8
  L  40 +---------+
  o     |   F2    |
  w     |         |
     7e +---------+  

  B  a1 +---------+     +---------+ 21
  y     |   F1    | =>  |   F1    |
  t     |         |     |         | 40 +---------+
  e     |         |     |         |    |  F2     |
  s     |         |     |         |    |         |
     fe +---------+     +---------+ 7e +---------+
                        21       48    49       70

----------------------------------------------------------
	Hi	Lo	Hop	Lop	hi	lo
----------------------------------------------------------
F1	a1-c8	a1-fe	CLR	CLR	21-48	21-7e
F2	a1-c8	40-7e	-58	NOP	49-70	40-7e
----------------------------------------------------------

================================================================
Notations:

	Hi: Hi byte ranges (in Big5 code)
	Lo: Lo byte ranges (in Big5 code)
	hi: Hi byte ranges (in B5E2 representation)
	lo: Lo byte ranges (in B5E2 representation)
	Hop: operations on Hi bytes (Big5->B5E2)
	Lop: operations on Li bytes (Big5->B5E2)

		NOP: no operation
		CLR: clear the 8th bit
		-YY: add a negative offset 0xYY

	* all numbers are HEX numbers *
================================================================

5.2. Mapping of Less Frequently or Rarely Used Characters

The mapping of codes in the rarely used area is also easy. The largest
code space Rare-1 (R1) can still be changed to 7-bit simply by clearing
the 8th bits of the high bytes and low bytes.

Also, most of the codes in Rare-2 region (i.e., the 40-column R2 region
as shown in the next figure) can be changed to 7-bit by adding a
constant X-offset to the X-coordinates without changing the Y-coordinates.
The mapping table is shown as follows:

	** Mapping for Rarely Used Chars : **

        c9               f0  f1    fe
     40 +------------------+ +------+ 40
        |                  | |R3.1  |
        |                  | |      |
        |                  | +------+ 5e
        |        R2        | +------+ 5f
        |                  | |R3.2  |
        |                  | |      |
        |                  | +------+ 7d
     7e +------------------+ +----+++ <- R3.3 + R3.4 ( 0xfd7e, 0xfe7e )
                             f1 fc fd fe
     a1 +---------------------------+
        |                           |
        |                           |
        |                           |
        |                           |
        |                           |
        |           R1              |
        |                           |
        |                           |
        |                           |
        |                           |
        |                           |
     fe +---------------------------+
        c9                         fe
                    |
                    |
                    V 
    21   2e 2f  3c 3d 48
 21 +------++------++--+ 21 +---------------------------+ 21   (+--+ : R3.3)
    |R3.1  ||R3.2  |++   22 |                           | 22   (++   : R3.4)
    |      ||      | 3e     |                           |
 3f +------++------+     3f |                           |
 40 +------------------+    |                           |
    |                  |    |                           |
    |                  |    |          R1               |
    |                  |    |                           |
    |       R2         |    |                           |
    |                  |    |                           |
    |                  |    |                           |
    |                  |    |                           |
 7e +------------------+    +---------------------------+
    21                 48   49                         7e

----------------------------------------------------------
	Hi	Lo	Hop	Lop	hi	lo
----------------------------------------------------------
R1	c9-fe	a1-fe	CLR	CLR	49-7e	21-7e
R2	c9-f0	40-7e	-a8	NOP	21-48	40-7e
R3.1	f1-fe	40-5e	-d0	-1f	21-2e	21-3f
R3.2	f1-fe	5f-7d	-c2	-3e	2f-3c	21-3f
R3.3	f1-fc	7e	-b4	-5d	3d-48	21
R3.4	fd-fe	7e	-c0	-5c	3d-3e	22
----------------------------------------------------------

Note that: the transformed X-coordinates of R1+R2 occupy all the high
byte ranges of 0x21-0x7e. Therefore, we are left with 14 columns of codes
in the rarely used region Rare-2 (i.e., 882 codes, BUT, including 5 columns
of user defined codes).

All these columns can be further divided into two small rectangular areas
and one small row of codes so that they are moved to the unused part of
the (0x21-0x7e,0x21-0x7e) area simply by adding a constant (X,Y)
translation vector to each rectangular region.
---
** We can discard the R3.4 region, which contains only two user-defined codes
	in practical implementation.
---

If we regard bit-clear (&0x7f or -0x80) and NOP (no operation) as two special
cases for adding constant offsets, then the above mapping can be implemented
with 8 (or 7) offset vectors. We can therefore map the 8-bit big5 codes
into 7-bit stream without using any multiplication or division operations
or resorting to any table lookup. (Note that at most 6 byte-comparisons are
needed to decide which region the current code belongs to. Mostly, only
about 3 comparisons are needed.)

Since the major operation for the largest blocks in F1, F2, R1 and R2
is the bit-clear operation, as in the B5E1 proposal, the computation load is
thus comparable with the B5E1 approach while reducing the block switching
frequency to a very negligible extent.

The b5encode.c and b5decode.c for this proposal is accessible from the ftp
site:

	hermes.ee.nthu.edu.tw:/pub/shin/hzb5encode/b5encode-2

to show the simple implementation.

When choosing the 'appropriate blocks', the philosophy is to retain the
geometry of the blocks of continuous codes and their sizes as closely to their
BIG5 origins as possible, and the largest blocks are fit to the printable area
first with the simplest possible operations. With this strategy, only those
less frequently used chars, whose low bytes lie in the 0x40-0x7e range are
actually divided somewhat differently from their Big5 origins.

6. Mapping Method III: The B5E3 Mapping Method (YAB5E)

Another method, which retains the simplicity of encoding/decoding by
bit-clear/set and removes the undesirable block switching effects, is
described here as B5E3 (or YAB5E, namely, Yet Another Big5 Encoding
scheme. Since the triggering idea is borrowed from Ya-Gui Wei's HZ-2,
it could also be called YA-gui's value-added Big5 Encoding scheme. -^^-)

The major idea is to divide the code space into two blocks so that half of
the high-byte ranges (0xa1-0xcf) are designated as Block 1 and the
remaining half (0xd0-0x7e) are designated as Block 2 of the Big5
code. With such an arrangement, the encoding and decoding are both easy
and symmetric. The mapping tables are shown as follows.


        High Bytes
        a1      cf
  L  40 +---------+
  o     |   F2+   |
  w     |         |
     7e +---------+  

  B  a1 +---------+     +---------+ 21
  y     |   F1+   | =>  |   F1+   |
  t     |         |     |         | 40 +---------+
  e     |         |     |         |    |  F2+    |
  s     |         |     |         |    |         |
     fe +---------+     +---------+ 7e +---------+
                        21       4f    50       7e

----------------------------------------------------------
	Hi	Lo	Hop	Lop	hi	lo
----------------------------------------------------------
F1+	a1-cf	a1-fe	CLR	CLR	21-4f	21-7e
F2+	a1-cf	40-7e	-51	NOP	50-7e	40-7e
----------------------------------------------------------

        High Bytes
        d0      fe
  L  40 +---------+
  o     |   R2+   |
  w     |         |
     7e +---------+  

  B  a1 +---------+                    +---------+ 21
  y     |   R1+   | =>                 |   R1+   |
  t     |         |     +---------+ 40 |         |
  e     |         |     |   R2+   |    |         |
  s     |         |     |         |    |         |
     fe +---------+     +---------+ 7e +---------+ 7e
                        21       4f    50       7e

----------------------------------------------------------
	Hi	Lo	Hop	Lop	hi	lo
----------------------------------------------------------
R1+	d0-fe	a1-fe	CLR	CLR	50-7e	21-7e
R2+	d0-fe	40-7e	-af	NOP	21-4f	40-7e
----------------------------------------------------------

For codes whose low bytes lie in the range of 0xa1-0xfe (F1+ and R1+),
the 8-th bit of their high bytes and low bytes are cleared during the
encoding process.

For codes with low bytes in the range of 0x40-0x7e (F2+ and R2+), their
high bytes are shifted by adding a constant offset so that they fall into
the remaining half of the printable ASCII area. The offsets for Block 1
and Block 2 codes are -0x51 and -0xaf respectively. The low bytes need
no change since they are already within 0x21-0x7e.

The decoding is also easy and symmetric. For the left half of the Block 1
codes in the printable ASCII area (0x21-0x4f) and Block 2 codes in the right
half (0x50-0x7e), the 8-th bit of their high bytes and low bytes are set to
'1'. For Block 1 codes in the right half (0x50-0x7e) and Block 2 codes in the
left half (0x21-0x4f), the high bytes are shifted by adding a constant offset
(+0x51 and +0xaf, respectively) without changing the low bytes.

The sample implementation of the b5encode.c and b5decode.c for this proposal
is accessible from the ftp site:

	hermes.ee.nthu.edu.tw:/pub/shin/hzb5encode/b5encode-3

to show the simple implementation.

The encoding/decoding process is almost as easy as for B5E1, except for
different numbers of range checking. (In B5E1, we check whether a code belongs
to the upper half or lower half; in B5E3, we also check whether a code belongs
to the right half or left half to decide the mapping operation: bit-clear or
byte offset.)

In the current arrangement of block boundary, all frequently used characters
plus several columns of less frequently used characters (with high byte in
the range of 0xc9-0xcf) are designated as Block 1. The remaining less
frequently used characters are designated as Block 2. As a result, as indicated
by Ya-Gui, the switching operations is even less than the case where the block
boundary is defined at the start of the less frequently used characters.
(This fact is also observed in a test over about 1M big5 files.)

7. Pros and Cons

There are major criticisms on not preserving the sorting sequence of the
original codes EXPLICITLY in B5E2. Since the current design is aimed at acting
as a code exchange media, not for information processing directly over the
7-bit exchange codes (especially for the computation environments of the Big5
users), the chances to use such sorting sequence is close to zero. (In fact,
it is almost equally true in the original Big5 code space for using such
sorting sequence.) Even in the very rare cases, the switching between the
two code spaces could be done within bit or byte changes. Therefore, it
means little for designing a mapping scheme. 

There are also concerns for future ISO-2022 compatibility in terms of the
division of the Big5 code. However, the designation of which characters as
block 1 chars and which characters as block 2 chars are not yet decided for
Big5 except for some private designations. So it will probably depend on what
division is widely accepted after the Big5/7 standard is settled by the
chinese computing societies.

The major discussions on the advantages or disadvantages of the above
proposals are accessible at:

	hermes.ee.nthu.edu.tw:/pub/shin/hzb5encode/doc/disc.b5e

Since B5E3 is new to the discussion list, further comments from all parties
will be added to the file.

Other discussions on 7-bit representations of Big5 code are also available
in the same directory. You can read them as ordinary emails, say, by using
'mail -f disc.b5e' in the UNIX environment for all such files.

-----------------------------------------------------------------------
				Natural Language Processing Lab
				Department of Electrical Engineering
Jing-Shin Chang			National Tsing-Hua University
shin@hermes.ee.nthu.edu.tw	Hsinchu, Taiwan 30043, R.O.C.
-----------------------------------------------------------------------
